am: Use cat instead of echo to avoid DOS line-endings (fixes t4150)
[git/dscho.git] / git-mergetool--lib.sh
blobed630b208a80a36d729b5074a39bc53df0cabd59
1 #!/bin/sh
2 # git-mergetool--lib is a library for common merge tool functions
3 diff_mode() {
4 test "$TOOL_MODE" = diff
7 merge_mode() {
8 test "$TOOL_MODE" = merge
11 translate_merge_tool_path () {
12 echo "$1"
15 check_unchanged () {
16 if test "$MERGED" -nt "$BACKUP"
17 then
18 status=0
19 else
20 while true
22 echo "$MERGED seems unchanged."
23 printf "Was the merge successful? [y/n] "
24 read answer || return 1
25 case "$answer" in
26 y*|Y*) status=0; break ;;
27 n*|N*) status=1; break ;;
28 esac
29 done
33 valid_tool_config () {
34 if test -n "$(get_merge_tool_cmd "$1")"
35 then
36 return 0
37 else
38 return 1
42 valid_tool () {
43 setup_tool "$1" || valid_tool_config "$1"
46 setup_tool () {
47 case "$1" in
48 vim*|gvim*)
49 tool=vim
52 tool="$1"
54 esac
55 mergetools="$(git --exec-path)/mergetools"
57 # Load the default definitions
58 . "$mergetools/defaults"
59 if ! test -f "$mergetools/$tool"
60 then
61 return 1
64 # Load the redefined functions
65 . "$mergetools/$tool"
67 if merge_mode && ! can_merge
68 then
69 echo "error: '$tool' can not be used to resolve merges" >&2
70 exit 1
71 elif diff_mode && ! can_diff
72 then
73 echo "error: '$tool' can only be used to resolve merges" >&2
74 exit 1
76 return 0
79 get_merge_tool_cmd () {
80 # Prints the custom command for a merge tool
81 merge_tool="$1"
82 if diff_mode
83 then
84 echo "$(git config difftool.$merge_tool.cmd ||
85 git config mergetool.$merge_tool.cmd)"
86 else
87 echo "$(git config mergetool.$merge_tool.cmd)"
91 # Entry point for running tools
92 run_merge_tool () {
93 # If GIT_PREFIX is empty then we cannot use it in tools
94 # that expect to be able to chdir() to its value.
95 GIT_PREFIX=${GIT_PREFIX:-.}
96 export GIT_PREFIX
98 merge_tool_path="$(get_merge_tool_path "$1")" || exit
99 base_present="$2"
100 status=0
102 # Bring tool-specific functions into scope
103 setup_tool "$1"
105 if merge_mode
106 then
107 merge_cmd "$1"
108 else
109 diff_cmd "$1"
111 return $status
114 guess_merge_tool () {
115 if merge_mode
116 then
117 tools="tortoisemerge"
118 else
119 tools="kompare"
121 if test -n "$DISPLAY"
122 then
123 if test -n "$GNOME_DESKTOP_SESSION_ID"
124 then
125 tools="meld opendiff kdiff3 tkdiff xxdiff $tools"
126 else
127 tools="opendiff kdiff3 tkdiff xxdiff meld $tools"
129 tools="$tools gvimdiff diffuse ecmerge p4merge araxis bc3"
131 case "${VISUAL:-$EDITOR}" in
132 *vim*)
133 tools="$tools vimdiff emerge"
136 tools="$tools emerge vimdiff"
138 esac
139 echo >&2 "merge tool candidates: $tools"
141 # Loop over each candidate and stop when a valid merge tool is found.
142 for i in $tools
144 merge_tool_path="$(translate_merge_tool_path "$i")"
145 if type "$merge_tool_path" >/dev/null 2>&1
146 then
147 echo "$i"
148 return 0
150 done
152 echo >&2 "No known merge resolution program available."
153 return 1
156 get_configured_merge_tool () {
157 # Diff mode first tries diff.tool and falls back to merge.tool.
158 # Merge mode only checks merge.tool
159 if diff_mode
160 then
161 merge_tool=$(git config diff.tool || git config merge.tool)
162 else
163 merge_tool=$(git config merge.tool)
165 if test -n "$merge_tool" && ! valid_tool "$merge_tool"
166 then
167 echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
168 echo >&2 "Resetting to default..."
169 return 1
171 echo "$merge_tool"
174 get_merge_tool_path () {
175 # A merge tool has been set, so verify that it's valid.
176 merge_tool="$1"
177 if ! valid_tool "$merge_tool"
178 then
179 echo >&2 "Unknown merge tool $merge_tool"
180 exit 1
182 if diff_mode
183 then
184 merge_tool_path=$(git config difftool."$merge_tool".path ||
185 git config mergetool."$merge_tool".path)
186 else
187 merge_tool_path=$(git config mergetool."$merge_tool".path)
189 if test -z "$merge_tool_path"
190 then
191 merge_tool_path="$(translate_merge_tool_path "$merge_tool")"
193 if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
194 ! type "$merge_tool_path" >/dev/null 2>&1
195 then
196 echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
197 "'$merge_tool_path'"
198 exit 1
200 echo "$merge_tool_path"
203 get_merge_tool () {
204 # Check if a merge tool has been configured
205 merge_tool="$(get_configured_merge_tool)"
206 # Try to guess an appropriate merge tool if no tool has been set.
207 if test -z "$merge_tool"
208 then
209 merge_tool="$(guess_merge_tool)" || exit
211 echo "$merge_tool"